Field< Data_T > Class Template Referenceabstract
Fields

`#include <Field.h>`

Inheritance diagram for Field< Data_T >:

## Classes

class | const_iterator

## Public Types

typedef Field< Data_T > | class_type
typedef boost::intrusive_ptr< Field > | Ptr
typedef Data_T | value_type
| Allows us to reference the template class.
typedef std::vector< Ptr > | Vec
| This is a convenience typedef for the list that Field3DInputFile::readScalarLayers() and Field3DInputFile::readVectorLayers() will return its data in.
Public Types inherited from FieldRes
typedef FieldRes | class_type
typedef boost::intrusive_ptr< FieldRes > | Ptr
typedef std::vector< Ptr > | Vec
Public Types inherited from FieldBase
typedef FieldBase | class_type
typedef boost::intrusive_ptr< FieldBase > | Ptr
Public Types inherited from RefBase
typedef boost::intrusive_ptr< RefBase > | Ptr
typedef boost::weak_ptr< RefBase > | WeakPtr

## Public Member Functions

const_iterator | cbegin () const
| Const iterator to first element. "cbegin" matches the tr1 c++ standard.
const_iterator | cbegin (const Box3i &subset) const
| Const iterator to first element of specific subset.
const_iterator | cend () const
| Const iterator pointing one element past the last valid one.
const_iterator | cend (const Box3i &subset) const
| Const iterator pointing one element past the last valid one (for a subset).
virtual std::string | dataTypeString () const
virtual Data_T | value (int i, int j, int k) const =0
| Read access to a voxel. The coordinates are in integer voxel space .
virtual | ~Field ()
| Dtor.
Public Member Functions inherited from FieldRes
V3i const | dataResolution () const
const Box3i & | dataWindow () const
| Returns the data window. Any coordinate inside this window is safe to pass to value() in the Field subclass.
const Box3i & | extents () const
| Returns the extents of the data. This signifies the relevant area that the data exists over. However, the data window (below) may be smaller than the extents, in which case it is only safe to call value() for those coordinate inside the data window.
| FieldRes ()
| This constructor ensures that we have a valid mapping at all times.
| FieldRes (const FieldRes &src)
| Base class copy constructor.
bool | isInBounds (int i, int j, int k) const
| Returns true is the indicies are in bounds of the data window.
FieldMapping::Ptr | mapping ()
| Returns a pointer to the mapping.
const FieldMapping::Ptr | mapping () const
| Returns a pointer to the mapping.
virtual void | mappingChanged ()
| Tells the subclass that the mapping changed.
virtual long long int | memSize () const
| Returns the memory usage (in bytes).
void | setMapping (FieldMapping::Ptr mapping)
| Sets the field's mapping.
virtual size_t | voxelCount () const
| Counts the number of voxels. For most fields, this is just the volume of the data window, but sparse data structures can override this to return a better value.
Public Member Functions inherited from FieldBase
| FieldBase ()
| Constructor.
| FieldBase (const FieldBase &)
| Copy Constructor.
virtual | ~FieldBase ()
| Destructor.
virtual std::string | className () const =0
| Returns the class name of the object. Used by the class pool and when writing the data to disk.
virtual std::string | classType () const =0
| Returns the full class type string.
virtual Ptr | clone () const =0
| Returns a pointer to a copy of the field, pure virtual so ensure derived classes properly implement it.
FieldMetadata & | metadata ()
| accessor to the m_metadata class
const FieldMetadata & | metadata () const
| Read only access to the m_metadata class.
void | copyMetadata (const FieldBase &field)
| Copies the metadata from a second field.
Public Member Functions inherited from RefBase
void | ref () const
| Used by boost::intrusive_pointer.
size_t | refcnt ()
| Used by boost::intrusive_pointer.
void | unref () const
| Used by boost::intrusive_pointer.
WeakPtr | weakPtr () const
| RefBase ()
| RefBase (const RefBase &)
| Copy constructor.
RefBase & | operator= (const RefBase &)
| Assignment operator.
virtual | ~RefBase ()
| Destructor.
virtual bool | checkRTTI (const char *typenameStr)=0
| This function is only implemented by concrete classes and triggers the actual RTTI check through matchRTTI();.
bool | matchRTTI (const char *typenameStr)
| Performs a check to see if the given typename string matches this class' This needs to be implemented in -all- subclasses, even abstract ones.
Public Member Functions inherited from MetadataCallback
virtual void | metadataHasChanged (const std::string &)
| Alerts the callback holder that the metadata has changed.

## Static Public Member Functions

static const char * | staticClassName ()
static const char * | staticClassType ()
Static Public Member Functions inherited from FieldRes
static const char * | staticClassName ()
static const char * | staticClassType ()
Static Public Member Functions inherited from FieldBase
static const char * | staticClassName ()
static const char * | staticClassType ()
static const char * | staticClassType ()

## Public Attributes

| DEFINE_FIELD_RTTI_ABSTRACT_CLASS
Public Attributes inherited from FieldRes
| DEFINE_FIELD_RTTI_ABSTRACT_CLASS
Public Attributes inherited from FieldBase
std::string | attribute
| Optional name of the attribute the field represents.
std::string | name
| Optional name of the field.

## Private Types

typedef FieldRes | base
| Convenience typedef for referring to base class.

## Static Private Attributes

static TemplatedFieldType< Field< Data_T > > | ms_classType

## Additional Inherited Members

Protected Types inherited from FieldRes
typedef MatrixFieldMapping | default_mapping
Protected Attributes inherited from FieldRes
Box3i | m_dataWindow
| Defines the area where data is allocated. This should be treated as a closed (i.e. inclusive) interval.
Box3i | m_extents
| Defines the extents of the the storage. This may be larger or smaller than the data window, and in the case where it is larger, care must be taken not to access voxels outside the data window. This should be treated as a closed (i.e. inclusive) interval.
FieldMapping::Ptr | m_mapping
| Pointer to the field's mapping.

## Detailed Description

template<class Data_T>
class Field< Data_T >

This class provides read-only access to voxels. A read-only buffer can not be resized. Resizing is added by ResizableField. The object still has a size of course, but it can only be set by subclass-specific methods.

Note
  Regarding the template type Data_T. This does not necessarily have to be the internal data storage format, it only defines the -return type- that the particular Field instance provides.

Definition at line 389 of file Field.h.

## Member Typedef Documentation

## Ptr

template<class Data_T>

typedef boost::intrusive_ptr<Field> Field< Data_T >::Ptr

Definition at line 395 of file Field.h.

## value_type

template<class Data_T>

typedef Data_T Field< Data_T >::value_type

Allows us to reference the template class.

Definition at line 398 of file Field.h.

## Vec

template<class Data_T>

typedef std::vector<Ptr> Field< Data_T >::Vec

This is a convenience typedef for the list that Field3DInputFile::readScalarLayers() and Field3DInputFile::readVectorLayers() will return its data in.

Definition at line 403 of file Field.h.

## class_type

template<class Data_T>

typedef Field<Data_T> Field< Data_T >::class_type

Definition at line 407 of file Field.h.

## base

template<class Data_T>

typedef FieldRes Field< Data_T >::base

private

Convenience typedef for referring to base class.

Definition at line 467 of file Field.h.

## Constructor & Destructor Documentation

## ~Field()

template<class Data_T>

virtual Field< Data_T >::~Field | ( |  | ) |

inline virtual

Dtor.

Definition at line 423 of file Field.h.

{ /* Empty */ }

## Member Function Documentation

## staticClassName()

template<class Data_T>

const char * Field< Data_T >::staticClassName | ( |  | ) |

inline static

Definition at line 410 of file Field.h.

{
return "Field";
}

## staticClassType()

template<class Data_T>

const char * Field< Data_T >::staticClassType | ( |  | ) |

inline static

Definition at line 415 of file Field.h.

{
return Field<Data_T>::ms_classType.name();
}
FieldBase::name
std::string name
Optional name of the field.
Definition Field.h:171
Field
Definition Field.h:390

References ms_classType.

## cbegin() [1/2]

template<class Data_T>

Field< Data_T >::const_iterator Field< Data_T >::cbegin | ( |  | ) | const

Const iterator to first element. "cbegin" matches the tr1 c++ standard.

Definition at line 569 of file Field.h.

{
if (FieldRes::dataResolution() == V3i(0))
return cend();
return const_iterator(*this, m_dataWindow, m_dataWindow.min);
}
V3i
Imath::V3i V3i
Definition SpiMathLib.h:71
FieldRes::m_dataWindow
Box3i m_dataWindow
Defines the area where data is allocated. This should be treated as a closed (i.e....
Definition Field.h:310
Field::const_iterator
Definition Field.h:492
Field::cend
const_iterator cend() const
Const iterator pointing one element past the last valid one.
Definition Field.h:591

References cend(), FieldRes::dataResolution(), and FieldRes::m_dataWindow.

Referenced by ResizableField< Data_T >::copyFrom(), ResizableField< Data_T >::copyFrom(), and isIdentical().

## cbegin() [2/2]

template<class Data_T>

Field< Data_T >::const_iterator Field< Data_T >::cbegin | ( | const Box3i & | subset | ) | const

Const iterator to first element of specific subset.

Definition at line 580 of file Field.h.

{
if (subset.isEmpty())
return cend(subset);
return const_iterator(*this, subset, subset.min);
}

References cend().

## cend() [1/2]

template<class Data_T>

Field< Data_T >::const_iterator Field< Data_T >::cend | ( |  | ) | const

Const iterator pointing one element past the last valid one.

Definition at line 591 of file Field.h.

{
return const_iterator(*this, m_dataWindow,
V3i(m_dataWindow.min.x,
m_dataWindow.min.y,
m_dataWindow.max.z + 1));
}

References FieldRes::m_dataWindow.

Referenced by cbegin(), cbegin(), and isIdentical().

## cend() [2/2]

template<class Data_T>

Field< Data_T >::const_iterator Field< Data_T >::cend | ( | const Box3i & | subset | ) | const

Const iterator pointing one element past the last valid one (for a subset).

Definition at line 603 of file Field.h.

{
return const_iterator(*this, subset, V3i(subset.min.x,
subset.min.y,
subset.max.z + 1));
}

## value()

template<class Data_T>

virtual Data_T Field< Data_T >::value | ( | int | i,
|  | int | j,
|  | int | k ) const

pure virtual

Read access to a voxel. The coordinates are in integer voxel space .

Note
  Before the internal storage is accessed, the subclass must compute the data window coordinates by looking at Field::m_dataWindow.
  Virtual functions are known not to play nice with threading. Therefor, concrete classes can implement (by convention) fastValue() as a non-virtual function.

Implemented in DenseField< Data_T >, DenseField< double >, DenseField< float >, DenseField< half >, DenseField< V3d >, DenseField< V3f >, DenseField< V3h >, EmptyField< Data_T >, EmptyField< float >, MACField< Data_T >, MACField< V3d >, MACField< V3f >, MACField< V3h >, MIPField< Field_T >, MIPField< DenseField< Data_T > >, MIPField< SparseField< Data_T > >, ProceduralField< Data_T >, ProceduralField< double >, ProceduralField< float >, ProceduralField< half >, ProceduralField< V3d >, ProceduralField< V3f >, ProceduralField< V3h >, Ptr< float >, real_t< Data_T >, SparseField< Data_T >, SparseField< double >, SparseField< float >, SparseField< half >, SparseField< V3d >, SparseField< V3f >, and SparseField< V3h >.

Referenced by WritableField< Data_T >::clear(), CubicFieldInterp< Data_T >::sample(), and LinearFieldInterp< Data_T >::sample().

## dataTypeString()

template<class Data_T>

virtual std::string Field< Data_T >::dataTypeString | ( |  | ) | const

inline virtual

Reimplemented from FieldRes.

Definition at line 454 of file Field.h.

{ return DataTypeTraits<Data_T>::name(); }
DataTypeTraits::name
static std::string name()
Definition Traits.h:267

References DataTypeTraits< T >::name().

## Member Data Documentation

## DEFINE_FIELD_RTTI_ABSTRACT_CLASS

template<class Data_T>

Field< Data_T >::DEFINE_FIELD_RTTI_ABSTRACT_CLASS

Definition at line 408 of file Field.h.

## ms_classType

template<class Data_T>

TemplatedFieldType<Field<Data_T> > Field< Data_T >::ms_classType

static private

Definition at line 462 of file Field.h.

Referenced by staticClassType().

The documentation for this class was generated from the following file:

- export/Field.h